import java.lang.*;

/*
-------------------------------------------------------------------------------
Equacions de Lotka-Volterra (versio normalitzada)
-------------------------------------------------------------------------------
Dades: rx (factor de creixement especie X), ry (factor de creixement especie
       Y), alfa (influencia de Y sobre X, parametre normalitzat), beta
       (influencia de X sobre Y, parametre normalitzat), x (nombre inicial
       exemplars de l'especie X, normalitzat), y (nombre inicial exemplars
       especie Y, normalitzat), max (nombre de passos).
Resultats: Fitxer "herba1.dat", amb tres columnes. Cada fila representa un
           instant de temps. La primera columna es l'ordinal de l'instant
           de temps, la segona el nombre d'exemplars de l'espcie X i la
           tercera el nombre d'exemplars de l'especie Y.
Dades de prova: rx=2.0 ry=2.0 alfa=0.75 beta=0.75 x=0.1 y=0.05 max=2 ==>
                0, 0.1, 0.05; 1, 0.1725, 0.0875; 2, 0.262847, 0.137047
Observacions: -
-------------------------------------------------------------------------------
*/

public class Herba1Calculs {
	double alfa,beta,rx,ry,x,y,trajx[],trajy[];
	int max;

	Herba1Calculs(float rx0,float ry0,float alfa0,float beta0,float x0,float y0, int max0) {
		double xn,yn;
		int n;

		alfa = (double) alfa0;
		beta = (double) beta0;
		rx = (double) rx0;
		ry = (double) ry0;
		x = (double) x0;
		y = (double) y0;
		max = max0;
		trajx = new double[max];
		trajy = new double[max];

		trajx[0]=x;
		trajy[0]=y;
		for(n=1;n<max;n++) {
			xn=rx*x*(1.0-x-alfa*y);
			yn=ry*y*(1.0-y-beta*x);
			x=xn;
			y=yn;
			trajx[n] = x;
			trajy[n] = y;
		}
	}
}
